<template>
  <div class="ob-order" v-if="!isLoading">
    <div class="ob-main-template-header anon-header">
      <div class="anon-header__log">
        <svg
          v-if="platform === 'oboz'"
          width="94"
          height="28"
          viewBox="0 0 94 28"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M64.5793 6.99223C59.5077 6.99223 55.1607 10.3613 53.9583 14.9372H48.4677C47.3474 10.3613 43.2912 6.99223 38.3996 6.99223C36.575 6.99223 35.0079 7.39539 33.7404 8.25254H33.2436V0H26.8361V17.4961C26.8361 23.2584 31.8093 28 37.7897 28C43.0011 28 47.2859 24.5756 48.4565 20.0099H53.9521C55.1452 24.5756 59.4977 28 64.5793 28C70.7123 28 75.564 23.2584 75.564 17.4961C75.564 11.6739 70.7123 6.99223 64.5793 6.99223Z"
            fill="white"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M37.772 21.9674C35.3006 21.9674 33.2258 19.9269 33.2258 17.4961C33.2258 14.9748 35.3006 13.0242 37.772 13.0242C40.3347 13.0242 42.3483 14.9748 42.3483 17.4961C42.3483 19.9269 40.3347 21.9674 37.772 21.9674Z"
            fill="#01245E"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M64.5619 21.9674C62.091 21.9674 60.0165 19.9269 60.0165 17.4961C60.0165 14.9748 62.091 13.0242 64.5619 13.0242C67.125 13.0242 69.1386 14.9748 69.1386 17.4961C69.1386 19.9269 67.125 21.9674 64.5619 21.9674Z"
            fill="#01245E"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M64.6003 15.6748C63.5784 15.6748 62.7485 16.4902 62.7485 17.4961C62.7485 18.5015 63.5784 19.3169 64.6003 19.3169C65.6226 19.3169 66.452 18.5015 66.452 17.4961C66.452 16.4902 65.6226 15.6748 64.6003 15.6748Z"
            fill="white"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M37.7948 15.6521C36.7721 15.6521 35.9434 16.4679 35.9434 17.4734C35.9434 18.4792 36.7721 19.2942 37.7948 19.2942C38.8179 19.2942 39.6461 18.4792 39.6461 17.4734C39.6461 16.4679 38.8179 15.6521 37.7948 15.6521Z"
            fill="white"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M10.9533 28C16.1647 28 20.4486 24.5755 21.6189 20.0099H24.6064V14.9371H21.6131C20.4335 10.3612 16.155 6.99219 10.9533 6.99219C4.97324 6.99219 0 11.6739 0 17.4961C0 23.2583 4.97324 28 10.9533 28Z"
            fill="white"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M6.40759 17.4961C6.40759 14.9748 8.48162 13.0242 10.9533 13.0242C13.5164 13.0242 15.5297 14.9748 15.5297 17.4961C15.5297 19.9269 13.5164 21.9674 10.9533 21.9674C8.48162 21.9674 6.40759 19.9269 6.40759 17.4961Z"
            fill="#01245E"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M10.9761 15.6521C9.95344 15.6521 9.12476 16.4679 9.12476 17.4734C9.12476 18.4792 9.95344 19.2942 10.9761 19.2942C11.9984 19.2942 12.8279 18.4792 12.8279 17.4734C12.8279 16.4679 11.9984 15.6521 10.9761 15.6521Z"
            fill="white"
          />
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M91.8524 17.5846C93.5288 16.5188 94 14.8614 94 13.1576C94 9.93063 91.3233 7.46655 85.5274 7.46655H79.0022C78.4867 7.46655 78.0688 7.88442 78.0688 8.39989V12.4289C78.0688 12.9444 78.4867 13.3622 79.0022 13.3622H86.4982C87.793 13.3622 88.3516 13.8319 88.3516 14.8291C88.3516 15.1913 88.2769 15.4834 88.1208 15.7092H82.4388V19.7565H88.1208C88.2769 19.983 88.3516 20.2744 88.3516 20.6369C88.3516 21.6338 87.793 22.1035 86.4982 22.1035H78.488C77.9726 22.1035 77.5547 22.5213 77.5547 23.0368V27.0666C77.5547 27.582 77.9726 27.9999 78.488 27.9999H85.5274C91.3233 27.9999 94 25.5362 94 22.3085C94 20.6043 93.5288 18.9473 91.8524 17.8815V17.5846Z"
            fill="white"
          />
        </svg>

        <svg
          v-if="platform === 'gruzi'"
          width="970"
          height="299"
          viewBox="0 0 970 299"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M169.925 80.5777L184.308 110.78H147.632C120.307 110.78 113.116 119.05 113.116 152.49C113.116 186.287 120.307 194.198 147.632 194.198H184.308L169.925 224.4C162.015 226.198 151.948 227.276 144.756 227.276C90.4628 227.276 77.1602 212.535 77.1602 152.49C77.1602 92.803 90.4628 77.7017 144.756 77.7017C151.948 77.7017 162.015 78.7804 169.925 80.5777Z"
            fill="#FFFFFF"
          />
          <path
            d="M0.573242 149.613C0.573242 37.7905 38.3266 0.755798 151.228 0.755798C264.129 0.755798 301.881 37.7905 301.881 149.613C301.881 209.3 291.096 247.772 263.769 270.424L242.196 245.254C261.971 226.557 270.241 195.996 270.241 149.613C270.241 59.7238 239.679 29.8811 151.228 29.8811C62.7759 29.8811 32.2146 59.7238 32.2146 149.613C32.2146 234.469 61.6986 269.705 133.249 269.705C173.16 269.705 184.307 261.076 184.307 223.681V80.5784H220.263V223.681C220.263 281.929 204.083 298.829 129.655 298.829C39.4052 298.829 0.573242 254.244 0.573242 149.613Z"
            fill="#FFFFFF"
          />
          <path
            d="M460.078 56.7785C475.745 56.7785 499.619 58.5185 510.311 60.5079L512.798 86.6199H460.078C423.522 86.6199 414.322 98.3052 414.322 146.301C414.322 194.297 423.522 205.984 460.078 205.984H487.929V147.547L520.258 144.561V205.984L517.773 232.095C505.586 234.084 477.983 235.825 460.078 235.825C401.638 235.825 381.994 213.444 381.994 146.301C381.994 79.1599 401.638 56.7785 460.078 56.7785Z"
            fill="#FFFFFF"
          />
          <path
            d="M550.113 233.339V109H581.199V136.356L593.881 109C600.844 107.506 608.056 106.511 614.273 106.511C624.468 106.511 634.169 107.506 641.131 109L643.616 136.356H581.199V233.339H550.113Z"
            fill="#FFFFFF"
          />
          <path
            d="M664.764 109H695.846V171.168C695.846 200.264 701.566 207.228 722.952 207.228H754.533V109H785.618V233.339H754.533V207.724L742.348 233.339C735.632 234.829 726.93 235.825 720.466 235.825C674.958 235.825 664.764 217.673 664.764 171.168V109Z"
            fill="#FFFFFF"
          />
          <path
            d="M871.678 141.327V136.356H811.995L809.261 109H913.705V137.596L847.557 201.012V205.984H917.434V233.339H805.527V204.743L871.678 141.327Z"
            fill="#FFFFFF"
          />
          <path
            d="M968.421 233.339H937.336V109H968.421V233.339ZM953.005 56.7788C966.681 56.7788 969.666 61.7495 969.666 74.6802C969.666 87.6148 966.681 92.5855 953.005 92.5855C939.326 92.5855 936.096 87.6148 936.096 74.6802C936.096 61.7495 939.326 56.7788 953.005 56.7788Z"
            fill="#FFFFFF"
          />
        </svg>
      </div>
      <div class="anon-header__info">
        Гость
        <i class="icon role-client"></i>
      </div>
    </div>
    <!-- .ob-order__header -->
    <div class="ob-order__header">
      <div class="ob-order__header-content">
        <!-- .order-info -->
        <div class="order-info">
          <obTooltip
            v-if="uploadedFromFile"
            content="Заказ загружен из файла "
            position="top-start"
          >
            <i class="icon document"></i>
          </obTooltip>

          <obTooltip
            v-else
            content="Заказ создан вручную пользователем"
            position="top-start"
          >
            <i class="icon hand"></i>
          </obTooltip>
          Заказ на перевозку {{ formData.bodySaveDraft.number }}
          <span class="status">Черновик</span>
        </div>
        <!-- /.order-info -->
      </div>
    </div>
    <div class="ob-order__content">
      <div class="ob-order__content-left">
        <transition name="fade">
          <order-anon-screen
            v-if="transports && cargoTypes"
            :addressFrom="addressFrom"
            :addressTo="addressTo"
            :formData="formData"
            :accountingItems="accountingItems"
            :dateFrom="formData.bodySaveDraft.route.departureDt"
            :dateTo="formData.bodySaveDraft.route.arriveDt"
            :locationsTypes="locationsTypes"
            :fromPoints="fromPoints || 1"
            :toPoints="toPoints || 1"
            :fromPointsShow="fromPointsShow"
            :toPointsShow="toPointsShow"
            :transportationWay="formData.bodySaveDraft.transportationWay"
            :transports="transports"
            :transport="
              formData.bodySaveDraft.serviceParams.serviceTypeUuid || ''
            "
            :transportTypes="transportTypes"
            :transportType="formData.bodySaveDraft.serviceParams.serviceUuid"
            :transportQty="formData.bodySaveDraft.serviceParams.count"
            :temperatureСonditions="temperatureСonditions"
            :temperatureCondition="formData.bodySaveDraft.temperatureModeUuid"
            :conditions="conditions"
            :isRouteValid="isRouteValid"
            :logchain="formData.logchain"
            :firstStepErrors="this.firstStepErrors"
            :isPrivateContainer="formData.bodySaveDraft.isPrivateContainer"
            :validation="{
              isCargoValid,
              isCargoCodeValid,
              isCargoWeightValid,
              isConsignorValid,
              isConsigneeValid,
            }"
            :errors="errors.errors"
            :contractor="formData.bodySaveDraft.contractor"
            :cargoTypes="cargoTypes"
            @addressFromChanged="setAddressFrom"
            @addressToChanged="setAddressTo"
            @needSavePoints="changePoints"
            @needSaveDate="setDate"
            @addLoadingPoint="onAddLoadingPoint"
            @addUnloadingPoint="onAddUnloadingPoint"
            @removeLoadingPoint="onRemoveLoadingPoint"
            @removeUnloadingPoint="onRemoveUnloadingPoint"
            @setAddresForLoadingPoint="onSetAddresForLoadingPoint"
            @setAddresForUnloadingPoint="onSetAddresForUnloadingPoint"
            @cargoTypeChanged="onCargoTypeChange"
            @insuranceCostChanged="onInsuranceCostChange"
            @cargoCodeChanged="onCargoCodeChanged"
            @transportationWaychanged="onTransportationWaychanged"
            @transportChanged="onTransportChanged"
            @transportTypeChanged="onTransportTypeChanged"
            @transportQtyChanged="onTransportQtyChanged"
            @conditionsSelect="onconditionsSelect"
            @temperatureSelect="ontemperatureSelect"
            @weightChanged="onCargoWeightChanged"
            @cargoChanged="onCargoChanged"
            @freightForwardingUnitUuidChanged="
              onFreightForwardingUnitUuidChanged
            "
          />
        </transition>
        <div class="order-step">
          <ob-button
            label="Узнать цену"
            :disabled="
              !isRouteValid ||
              !istransportValid ||
              isSaving ||
              !!priceForOnline.total_price
            "
            @click="toSecondScreen"
          />
        </div>
      </div>

      <div class="ob-order__content-right">
        <div class="ob-order__content-right-container">
          <div v-if="step === 1" class="ob-order__status">
            <div v-if="isSearchingTariff">
              <div class="tariff-loader">
                <h2>Поиск вариантов</h2>
                <img src="@/assets/images/search_tracking.gif" alt="" />
              </div>
            </div>
            <template
              v-if="
                !isSearchingTariff &&
                !tariffError &&
                !tariffEmpty &&
                !showTariff
              "
            >
              <div class="ob-order__status-item">
                <i :class="isRouteValid ? 'checked' : 'alert'" class="icon" />
                <span class="ob-order__status-label"
                  >Укажите пункты погрузки и разгрузки</span
                >
              </div>
              <div class="ob-order__status-item">
                <i
                  :class="istransportValid ? 'checked' : 'alert'"
                  class="icon"
                />
                <span class="ob-order__status-label"
                  >Выберите способ перевозки</span
                >
              </div>
              <!-- <div class="ob-order__action">
                <ob-button
                  label="Продолжить"
                  :isFullWidth="true"
                  :disabled="
                    !isClientValid ||
                      !isRouteValid ||
                      !isCargoValid ||
                      !isCargoCodeValid ||
                      !isCargoWeightValid ||
                      !istransportValid ||
                      hasFirstStepErrors ||
                      isSaving
                  "
                  data-qa="btnContinue"
                  @click="toSecondScreen"
                />
              </div> -->
            </template>

            <anon-sidebar
              v-if="role === 'anonymous' && !isSearchingTariff && showTariff"
              :orderType="formData.bodySaveDraft.orderType"
              :priceForOnline="priceForOnline"
              :contractor="formData.bodySaveDraft.contractor"
              :tariffs="this.tariff ? this.tariff.tariffInfo : []"
              :tariffError="tariffError"
              :logchainError="isLogchainError"
              :tariffEmpty="tariffEmpty"
              @tariffChanged="tafiffChanged"
              @retakeTariff="toSecondScreen"
            ></anon-sidebar>
          </div>

          <div
            v-if="!isSearchingTariff && showTariff && foundLogchains.length"
            class="ob-order__status"
          >
            <div class="info" v-if="role === 'anonymous'">
              <info-message
                message="Зарегистрируйтесь или войдите в систему, чтобы оформить заказ"
              />
            </div>
            <div class="ob-order__action">
              <ob-button
                label="Оформить"
                :isFullWidth="true"
                :disabled="isSaving"
                data-qa="btnOrderPlacement"
                @click="changeOrderStatus"
              />
            </div>
          </div>
        </div>
        <!-- <div class="ob-order-info-actions">
          <ob-button
            type="outline"
            label="Сохранить и выйти"
            :mini="true"
            data-qa="btnSaveAndExit"
            @click="saveAndExit"
          />
          <ob-button
            type="flat"
            label=""
            icon="trash"
            :mini="true"
            data-qa="btnDeleteOrder"
            @click="deleteOrder"
          />
        </div> -->
      </div>
    </div>
    <ob-modal
      ref="authModal"
      size="small"
      title="Войдите в систему для оформления заказа"
      data-qa="authModal"
      customClass="anon-auth-modal"
    >
      <auth-modal />
    </ob-modal>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { uuid } from "vue-uuid";
import cloneDeep from "clone-deep";
import moment from "moment";
import VueCookie from "vue-cookie";
import api from "@/api";
import draftErrors from "./components/draftErrors";
import json from "@/order-mock.json";
import { orderInitData } from "@/resources/order";
import orderAnonScreen from "@/components/Order/orderAnonScreen";
import obTooltip from "common-components/src/obComponents/obTooltip";
import obButton from "common-components/src/obComponents/obButton";
import anonSidebar from "@/components/Order/anonSidebar";
import ObTooltip from "common-components/src/obComponents/obTooltip";
import ObModal from "common-components/src/obComponents/obModal";
import InfoMessage from "@/components/Order/InfoMessage";
import authModal from "./components/authModal";

moment.locale("ru");

export default {
  name: "order-draft",

  locationTypes: {
    "жд станция": "train",
    "аэропорт": "airplane",
    "контейнерный терминал": "container",
    "морской порт": "ship",
    "опорная точка": "city",
    "пограничный переход": "restrict",
    "пункт таможенного оформления/свх": "police",
  },

  temperatureIcons: {
    "4a40a2fe-c283-40e3-a402-b5a46fdebc05": "room-temperature",
    "e1fdc890-c81b-4d96-b1b4-3524597c679c": "freezing",
    "092d2879-0678-496b-b7ce-0da21f5941ea": "cooling",
  },

  pageMap: ["ROUTE", "BRIF", "PARAMETERS", "SERVICES"],

  iconsMap: {
    CLIENT: "role-client",
    CLICAR: "role-domain-owner",
    CARRIER: "role-agent",
  },

  errorsMap: {
    RESOURCE_TYPE_NOT_DEFINED: "transportType",
    DEPARTURE_DT_BEFORE_NORMAL: "date",
    PVP_DT_NOT_FOUND: "date",
    BAD_CARRIER_ROLE: "carrierRole",
  },

  loghcainIconsMap: {
    "e7519b46-faf4-11e9-8f0b-362b9e155667": "truck",
    "e7519d9e-faf4-11e9-8f0b-362b9e155667": "train-sm",
    "e7519ee8-faf4-11e9-8f0b-362b9e155667": "container",
  },

  components: {
    obTooltip,
    obButton,
    orderAnonScreen,
    anonSidebar,
    ObTooltip,
    ObModal,
    InfoMessage,
    authModal,
  },

  data() {
    return {
      auth: {
        username: "",
        password: "",
      },
      logchainFindTookLong: false,
      logchainFindTimeout: null,
      logistsList: [],
      errors: new draftErrors(),
      foundLogchains: [],
      isSaving: false,
      firstStepErrors: {
        transportType: {
          valid: true,
          errorTooltip: "",
        },
        date: {
          valid: true,
          errorTooltip: "",
        },
        address: {
          valid: true,
          errorTooltip: "",
        },
        carrierRole: {
          valid: true,
          errorTooltip: "",
        },
      },
      isRouteButtonDisabled: false,
      actualTariff: "",
      onlinePrice: "",
      tariffEmpty: false,
      tariffByHandValue: "",
      enableTariffByHand: false,
      isOnlyManualTariff: false,
      cargoErrors: [],
      riskColor: "",
      isLoading: true,
      isLogchainError: false,
      client: "",
      formData: cloneDeep(orderInitData),
      mocks: json,
      oferta: false,
      uuid: "",
      isLoadingFirstScreen: true,
      step: null,
      contractors: [
        {
          acceptedColor: true,
          title: "Любой исполнитель",
          uuid: "1",
          top: true,
        },
        {
          acceptedColor: true,
          title: "На основе политики распределения",
          uuid: "2",
          top: true,
        },
        // TODO Uncomment this block when backend wil be ready
        // {
        //   acceptedColor: true,
        //   title: "Любой из моих контрагентов",
        //   uuid: "3",
        //   top: true,
        // },
      ],
      logist: "",
      locationsTypes: [],
      addressFrom: {
        coordinates: {},
        icon: "pin",
        label: "",
        isValid: true,
        popoverMessage: "",
      },
      addressTo: {
        coordinates: {},
        icon: "pin",
        label: "",
        isValid: true,
        popoverMessage: "",
      },
      fromPointsShow: false,
      toPointsShow: false,
      transports: [],
      transportTypes: [],
      transport: "",
      transportQty: 1,
      conditions: [],
      temperatureСonditions: [],
      cargoTypes: [],
      accountingItems: [],
      contacts: [],
      phones: [],
      securityItems: [],
      isSearchingTariff: false,
      tariff: null,
      showTariff: false,
      tariffError: false,
      brif: null,
      uploadedFromFile: false,
      priceForOnline: {},
    };
  },

  computed: {
    ...mapGetters({
      role: "user/role",
      userFirstName: "user/firstName",
      userLastName: "user/lastName",
      userUuid: "user/userUuid",
      contractorUuid: "user/participantUuid",
    }),
    platform() {
      return window.OBOZ_CONFIG.OBOZ_API_HOST.includes("oboz")
        ? "oboz"
        : "gruzi";
    },
    profitClass() {
      return this.formData.primeCost.profit / 100 > 0
        ? "profit--positive"
        : "profit--negative";
    },
    hasFirstStepErrors() {
      return !!(
        this.firstStepErrors.carrierRole.errorTooltip.length ||
        this.firstStepErrors.date.errorTooltip.length ||
        this.firstStepErrors.transportType.errorTooltip.length
      );
    },
    prepearedLogchain() {
      const points = this.formData.logchain?.baseLocations?.map(
        (item, index) => {
          return {
            count: item.count,
            eta_dt: item.date,
            is_main: false,
            location_title: item.russianName,
            location_uuid: item.uuid,
            ordinal: item.ordinal || index,
            direction: item.direction,
            resource_class_uuid: item.resourceClassUuid || null,
            location_type_icon: item.locationTypeIcon
              ? item.locationTypeIcon.toLowerCase()
              : "TRUCK",
            resource_count: item.count || 1,
            resource_title: item.title,
            limits: item.limits,
            visitPointFromCount: item.visitPointFromCount,
            visitPointToCount: item.visitPointToCount,
          };
        }
      );
      const startDate = this.formData.logchain?.baseLocations?.find(
        (item) => item.ordinal === 1
      ).date;
      const endDate = this.formData.logchain?.baseLocations?.find(
        (item) => item.ordinal === this.formData.logchain?.baseLocations.length
      ).date;
      return {
        main_data: {
          uuid: this.formData.logchain?.uuid || "",
          executorName: this.formData.logchain?.executorName,
          eta_end_dt: endDate,
          eta_start_dt: startDate,
          route_duration_in_sec: this.formData.logchain.routeDuration || 0,
          route_length_in_m: this.formData.logchain.routeLength || 0,
          total_price: this.formData.logchain?.tariff?.value || 0,
          vat: this.formData.bodySaveDraft.vat || 0,
          logchainServiceName:
            this.formData.logchain?.logchainServiceName || "",
          logchainServiceCount:
            this.formData.bodySaveDraft.serviceParams.count || "",
          is_multistop: this.formData.logchain.isMultistop || false,
          tariff: this.formData.logchain.tariff || "",
        },
        points,
      };
    },

    manualTariffTax() {
      return Math.ceil((this.tariffByHandValue * 1) / 6);
    },

    contractorModel() {
      return this.role === "client"
        ? "contractorUuid"
        : this.role === "anonyous"
        ? "contractorUuid"
        : "clientUuid";
    },
    contractorSelectLabel() {
      return this.role === "client"
        ? "Выбрать исполнителя"
        : this.role === "anonymous"
        ? "Выбрать исполнителя"
        : "Выбрать заказчика";
    },
    activeContractor() {
      return this.contractors.find(
        (item) => item.uuid === this.formData.bodySaveDraft.contractor.uuid
      );
    },
    hasAddressFrom() {
      return !!this.addressFrom.label && this.addressFrom.isValid;
    },
    hasAddressTo() {
      return !!this.addressTo.label && this.addressTo.isValid;
    },
    isAddressesValid() {
      return this.addressFrom.isValid && this.addressTo.isValid;
    },
    isRouteValid() {
      return this.hasAddressFrom && this.hasAddressTo && this.isAddressesValid;
    },
    istransportValid() {
      return !!this.formData.bodySaveDraft.serviceParams.serviceUuid;
    },
    isClientValid() {
      return this.formData?.bodySaveDraft?.contractorUuid;
    },
    isCargoValid() {
      const main =
        this.formData.parameters.cargoTypeUuid &&
        this.formData.parameters.insuranceCargo.cost;
      const errors =
        (this.errors.errors["CONTRACTOR_ERRORS"] &&
          this.errors.errors["CONTRACTOR_ERRORS"].length) ||
        (this.errors.errors["CARGO_ERRORS"] &&
          this.errors.errors["CARGO_ERRORS"].length);
      return main && !errors;
    },
    isCargoCodeValid() {
      return this.formData.bodySaveDraft.transportationWay === "CONTAINER" ||
        this.formData.bodySaveDraft.transportationWay === "RAIL"
        ? !!this.formData.cargo?.etsngs?.length
        : true;
    },
    isCargoWeightValid() {
      return this.formData.bodySaveDraft.transportationWay === "CONTAINER" ||
        this.formData.bodySaveDraft.transportationWay === "RAIL"
        ? !!this.formData.cargo.weightInKg
        : true;
    },
    isLogistValid() {
      return !!this.formData.bodySaveDraft.logist?.uuid?.length;
    },
    isConsignorValid() {
      if (!this.brif.visitPoints.length) return;

      const consignor = this.brif.visitPoints.filter(
        ({ type }) => type === "FROM"
      );
      if (!consignor.length) return;

      return consignor.every((point) => point.infographUuid);
    },
    isConsigneeValid() {
      if (!this.brif.visitPoints.length) return;

      const consignee = this.brif.visitPoints.filter(
        ({ type }) => type === "TO"
      );
      if (!consignee.length) return;

      return consignee.every((point) => point.infographUuid);
    },
    baseTotal() {
      return this.tariff.totalPrice / 100;
    },

    totalServices() {
      return this.tariff.totalPrice / 100 + this.tariff.vatValue / 100;
    },

    hasPoints() {
      return Boolean(
        this.formData.bodySaveDraft.route.points &&
          this.formData.bodySaveDraft.route.points.length
      );
    },
    fromPoints() {
      if (!this.hasPoints) return;

      const fromPoints = this.formData.bodySaveDraft.route.points.find(
        (point) => point.direction === "FROM"
      );
      if (!fromPoints) return;

      return fromPoints.visitPointCount;
    },
    toPoints() {
      if (!this.hasPoints) return;

      const toPoints = this.formData.bodySaveDraft.route.points.find(
        (point) => point.direction === "TO"
      );
      if (!toPoints) return;

      return toPoints.visitPointCount;
    },
    formattedBaseLocations() {
      const logchain = this.formData.logchain;
      if (
        !logchain ||
        !logchain.baseLocations ||
        logchain.baseLocations.length < 2
      )
        return;

      const logchainConsignor = logchain.baseLocations.find(
        (item) => item.direction === "FROM"
      );
      const logchainConsignee = logchain.baseLocations.find(
        (item) => item.direction === "TO"
      );

      return {
        consignor: { ...logchainConsignor },
        consignee: { ...logchainConsignee },
      };
    },
    addresses() {
      return {
        consignor: cloneDeep(this.addressFrom),
        consignee: cloneDeep(this.addressTo),
      };
    },
    baseServices() {
      if (!this.tariff || !this.tariff.baseServices) return [];

      return this.tariff.baseServices;
    },
    acceptedColor() {
      return this.contractors.forEach((item) => {
        if (
          this.formData.bodySaveDraft.acceptedCarrierColors &&
          this.formData.bodySaveDraft.acceptedCarrierColors.length
        ) {
          item.acceptedColor =
            item.riskColor &&
            this.formData.bodySaveDraft.acceptedCarrierColors.includes(
              item.riskColor
            );
          if (item.uuid === "1" || item.uuid === "2" || item.uuid === "3") {
            item.acceptedColor = true;
          }
        } else if (
          this.formData.parameters.cargoTypeUuid &&
          this.formData.parameters.insuranceCargo.cost &&
          this.formData.bodySaveDraft.acceptedCarrierColors &&
          !this.formData.bodySaveDraft.acceptedCarrierColors.length
        ) {
          item.acceptedColor = false;
        } else {
          item.acceptedColor = true;
        }
      });
    },
  },

  watch: {
    "formData.bodySaveDraft.clientUuid": {
      async handler(newVal) {
        if (this.role === "clicar" && newVal) {
          await this.getLogistsList(
            this.formData.bodySaveDraft.contractor.uuid,
            this.formData.bodySaveDraft.client.uuid
          );
        }
      },
      immediate: true,
    },
    $route(newVal) {
      if (newVal.params.id === "new-order") {
        this.$router.go();
      }
    },
    step: {
      handler: async function (newVal) {
        if (
          newVal === 1 &&
          (this.formData.bodySaveDraft.transportationWay === "CONTAINER" ||
            this.formData.bodySaveDraft.transportationWay === "RAIL")
        ) {
          api.resources
            .getForwardingUnitList()
            .then((res) => {
              this.accountingItems = res.data.content.reduce((acc, item) => {
                acc.push({ uuid: item.uuid, title: item.denomination });
                return acc;
              }, []);
            })
            .catch((e) => {
              console.error(e);
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка загрузки данных",
              });
            });
        }

        if (newVal === 2 || newVal === 3) {
          api.resources
            .getForwardingUnitList()
            .then((res) => {
              this.accountingItems = res.data.content.reduce((acc, item) => {
                acc.push({ uuid: item.uuid, title: item.denomination });
                return acc;
              }, []);
            })
            .catch((e) => {
              console.error(e);
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка загрузки данных",
              });
            });

          api.services
            .getActiveServiceRequirements()
            .then((res) => {
              this.securityItems = res;
            })
            .catch((e) => {
              console.error(e);
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка загрузки данных",
              });
            });

          this.getContacts();

          if (
            this.formData.parameters.contactPerson &&
            this.formData.parameters.contactPerson.fio
          ) {
            this.getPhones(this.formData.parameters.contactPerson.fio);
          }
        }
      },
      // immediate: true
    },
  },

  async mounted() {
    await this.getContractors();
    if (this.$route.params.id === "new-order") {
      const contractor = await api.orders.getParticipantForAnonymous();
      this.formData.bodySaveDraft.contractorUuid = contractor.uuid;
      const { notAuthorized: settings } = await api.orders.getAnonymousSettings(
        contractor.uuid,
        "NOT_AUTHORIZED"
      );
      this.formData.bodySaveDraft.orderType = "STANDARD";
      this.formData.bodySaveDraft.clientUuid = this.contractorUuid;
      this.formData.parameters.cargoTypeUuid = settings.cargoTypeUuid;
      this.formData.parameters.insuranceCargo.cost = settings.insuranceCost;
      await this.saveOrder();
    } else {
      await this.getOrder(this.$route.params.id);
    }

    VueCookie.set("anon_order_draft_uuid", this.$route.params.id);

    api.organisations
      .getParticipantInfo(this.contractorUuid)
      .then((res) => {
        this.client = res.data.title;
      })
      .catch((e) => {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных",
        });
      });

    api.locations
      .getLocationTypes()
      .then((res) => {
        this.locationsTypes = res.data.content;
      })
      .catch((e) => {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных",
        });
      });

    // api.cargo
    //   .getOrderCargoTypes(0, 76)
    //   .then((res) => {
    //     this.cargoTypes = res.data.content;
    //   })
    //   .catch((e) => {
    //     console.error(e);
    //     this.$notification({
    //       type: "system_notification_error",
    //       message: "Ошибка загрузки данных",
    //     });
    //   });
    await this.setTransports(this.formData.bodySaveDraft.transportationWay);
  },

  methods: {
    saveLogist($event) {
      this.formData.bodySaveDraft.logistUuid = $event;
      this.formData.bodySaveDraft.logist.firstname = null;
      this.formData.bodySaveDraft.logist.lastname = null;
      this.formData.bodySaveDraft.logist.email = null;
      this.formData.bodySaveDraft.logist.patronymic = null;
      this.saveOrder(false);
    },
    async getLogistsList(contractor, client) {
      const res = await api.orders.getLogistsList(contractor, client);
      this.logistsList = res.map((item) => {
        return {
          uuid: item.uuid,
          title: `${item.firstname} ${item.lastname}`,
        };
      });
      if (res.length === 1 && !this.formData.bodySaveDraft.logist.uuid) {
        this.formData.bodySaveDraft.logist.uuid = res[0].uuid;
        this.formData.bodySaveDraft.logistUuid = res[0].uuid;
      }
      if (!res.length) {
        this.logistsList.push({
          title: `${this.userFirstName} ${this.userLastName}`,
          uuid: this.userUuid,
        });

        this.formData.bodySaveDraft.logist = {
          firstname: this.userFirstName,
          lastname: this.userLastName,
          uuid: this.userUuid,
        };

        this.formData.bodySaveDraft.logistUuid = this.userUuid;
      }
    },

    onResetLogchain() {
      this.getOrder(this.$route.params.id);
    },
    checkContractor() {
      if (
        this.formData.bodySaveDraft.contractorUuid !== "1" &&
        this.formData.bodySaveDraft.contractorUuid !== "2"
      ) {
        this.errors.clear("CONTRACTOR_ERRORS");
        const activeContractor = {
          ...this.contractors.find(
            (item) => item.uuid === this.formData.bodySaveDraft.contractorUuid
          ),
        };
        if (
          !this.formData.bodySaveDraft.acceptedCarrierColors.includes(
            activeContractor.riskColor
          ) &&
          this.formData.parameters.cargoTypeUuid &&
          this.formData.parameters.insuranceCargo.cost &&
          activeContractor.icon !== "role-domain-owner"
        ) {
          this.errors.record("CONTRACTOR_ERRORS", [
            {
              code: "INCOMPATIBILITY_CONTRACTOR",
              description:
                "Выбранный вами исполнитель не соответствует уровню риска заказа, определённому вашим грузом. Выберите другого исполнителя ",
            },
          ]);
        }
      }
    },
    async getTemperatureRegim() {
      try {
        const res = await api.orders.getTemperatureRegim(this.$route.params.id);
        this.temperatureСonditions = this.prepareTempModes(res);
        if (!this.temperatureСonditions.length) {
          this.temperatureСonditions.push({
            temperatureModeTitle: "Не требуется",
            temperatureModeUuid: null,
          });
          this.formData.bodySaveDraft.temperatureRegimeUuid = null;
        }
      } catch (err) {
        console.error(err);
      }
    },
    prepareTempModes(payload) {
      const tempIconsMap = {
        temperature_mode_root_room_temperature: "room-temperature",
        temperature_mode_root_cooling: "cooling",
        temperature_mode_root_freezing: "freezing",
      };

      const temp = payload.map((item) => ({
        ...item,
        icon: tempIconsMap[item.temperatureModeRootTitle],
      }));
      temp.unshift({
        temperatureModeTitle: "Не требуется",
        temperatureModeUuid: null,
      });
      return temp;
    },

    resetTariffSidebar() {
      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;
      this.tariff = {};
    },
    async getTransports() {
      try {
        const res = await api.orders.getTransport(
        this.formData.bodySaveDraft.transportationWay
        );
        const transport = res.find(item => item.uuid === '56eaa734-ad65-47e2-b961-80797818e935')
        this.transports = transport ? [transport] : res;
      } catch (err) {
        console.error(err);
      }
    },
    async setTransports() {
      if (
        !this.formData.bodySaveDraft.transportationWay ||
        !this.formData.bodySaveDraft.transportationWay.length
      ) {
        this.formData.bodySaveDraft.transportationWay = "FTL";
      }

      try {
        await this.getTransports();
        if (!this.formData.bodySaveDraft.serviceParams.serviceTypeUuid) {
          this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = this.transports[0].uuid;
        }
        this.changeTransport();
      } catch (err) {
        console.error(err);
      }
    },

    closeLogchainError() {
      this.$refs.logchainsModalError.close();
    },

    closeLogchainNotFound() {
      this.$refs.logchainsModalNotFound.close();
    },

    retryFindLogchains() {
      this.findLogchains();
    },

    async onLogchainSelected($event) {
      await api.orders.saveLogchain($event);

      await api.orders.createGoGp(this.$route.params.id);

      // this.onRouteCompleted();
    },
    onSaveAndExit() {
      this.saveOrder();
      this.$router.push("/order__drafts");
    },
    clearFirstStepValidationField(field) {
      this.firstStepErrors[field].valid = true;
      this.firstStepErrors[field].errorTooltip = "";
    },
    updateTariffByHand(e) {
      this.tariffByHandValue = e;
    },
    tafiffChanged(e) {
      this.actualTariff = e;
    },
    getContacts() {
      api.orders
        .getOrderContacts(this.formData.bodySaveDraft.clientUuid)
        .then((res) => {
          this.contacts = res.data.map((item) => {
            return { title: item, uuid: uuid.v4() };
          });
        })
        .catch((err) => {
          console.error(err);
        });
    },
    getPhones(fio) {
      api.orders
        .getOrderContactPhones(this.formData.bodySaveDraft.clientUuid, fio)
        .then((res) => {
          this.phones = res.data.map((item) => {
            return { title: item, uuid: uuid.v4() };
          });
        });
    },
    async setOrderManualTariff() {
      let notificationId = new Date().getTime() + "save";
      this.$notification({
        type: "system_notification_in_load",
        message: "Сохранение",
        id: notificationId,
      });
      try {
        const res = await api.orders.setOrderManualTariff(
          this.$route.params.id,
          this.tariffByHandValue
        );
        if (res) {
          this.$notification({
            type: "system_notification_success",
            message: "Сохранено",
          });
          this.actualTariff = res.tariffUuid;
        } else {
          this.tariffError = true;
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка при сохранении тарифа",
          });
        }
      } catch (e) {
        console.error(e);
        this.tariffError = true;
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при сохранении тарифа",
        });
      } finally {
        this.$notification({ event: "close", id: notificationId });
      }
    },

    setTariffByHand() {
      this.enableTariffByHand = true;
    },

    setOnlinePrice() {
      this.isRouteButtonDisabled = true;
      api.orders
        .getOrderOnlinePrice(this.$route.params.id)
        .then((res) => {
          if (!res) {
            this.tariffError = true;
            this.formData.bodySaveDraft.tariffUuid = "";
            return;
          }
          this.formData.bodySaveDraft.tariffUuid = res.tariffUuid;
          // this.step = 2;
          this.saveOrder();
        })
        .catch((err) => {
          console.error(err);
        });
    },

    isEmptyObj(obj) {
      for (var key in obj) {
        if (obj.hasOwnProperty(key)) {
          return false;
        }
      }
      return true;
    },
    getUuid() {
      return uuid.v4();
    },
    changeOrderStatus() {
      this.onLogchainSelected(this.foundLogchains[0].main_data.uuid);
      this.$refs.authModal.open();
    },

    async onServiceChanged($event) {
      try {
        await api.orders.updateParameters(this.$route.params.id, $event);
        await this.getOrder(this.$route.params.id);
      } catch (error) {
        console.error(error);
      }
    },

    async validateFirstScreen() {
      for (let i in this.firstStepErrors) {
        this.firstStepErrors[i].valid = true;
        this.firstStepErrors[i].errorTooltip = "";
      }

      try {
        const validation = await api.orders.checkContinueFirst(
          this.$route.params.id
        );
        if (!validation.status) {
          validation.errors.forEach((item) => {
            this.firstStepErrors[
              this.$options.errorsMap[item.code]
            ].valid = false;
            this.firstStepErrors[
              this.$options.errorsMap[item.code]
            ].errorTooltip = item.description;
          });
          return;
        }
      } catch (e) {
        console.error(e);
      }
    },

    toSecondScreen() {
      this.validateFirstScreen()
        .then(async () => {
          if (this.hasFirstStepErrors) {
            return;
          } else {
            await api.orders.resetSnapshots(this.$route.params.id);
            this.isSearchingTariff = true;
            this.isLogchainError = false;
            await this.FindLogchainsForOnlinePrice();
            this.isSearchingTariff = false;
            this.showTariff = true;
          }
        })
        .catch((err) => {
          console.error(err);
        });
    },

    async findLogchains() {
      if (this.foundLogchains.length) {
        this.onLogchainSelected(this.foundLogchains[0].main_data.uuid);
        return;
      }
      this.foundLogchains = [];
      try {
        const transactionUuid = uuid.v4();
        this.logchainFindTimeout = setTimeout(() => {
          this.logchainFindTookLong = true;
        }, 90000);
        const logchains = await api.orders.findLogchains({
          draftUuid: this.$route.params.id,
          transactionUuid,
          userUuid: this.userUuid,
        });
        logchains.logchains.forEach((item) => {
          item.points.forEach((point) => {
            point.location_type_icon = point.location_type_icon.toLowerCase();
          });
        });
        this.foundLogchains = logchains.logchains;
        this.priceForOnline = this.foundLogchains[0].main_data;
        this.isRouteButtonDisabled = false;
      } catch (e) {
        if (e.status !== 404) {
          this.isRouteButtonDisabled = false;
          this.actualTariff = "";
          this.formData.bodySaveDraft.tariffUuid = "";
        } else if (e.status == 404) {
          this.isRouteButtonDisabled = false;
          this.formData.bodySaveDraft.tariffUuid = "";
        }
      } finally {
        clearTimeout(this.logchainFindTimeout);
        this.logchainFindTookLong = false;
      }
    },

    async FindLogchainsForOnlinePrice() {
      try {
        this.foundLogchains = [];
        this.priceForOnline = {};
        const transactionUuid = uuid.v4();
        const logchains = await api.orders.findLogchains({
          draftUuid: this.$route.params.id,
          transactionUuid,
          userUuid: this.userUuid,
        });

        this.foundLogchains = logchains.logchains;
        this.priceForOnline = this.foundLogchains[0].main_data;
      } catch (e) {
        if (e.status !== 404) {
          this.isRouteButtonDisabled = false;
          this.tariffError = true;
          this.actualTariff = "";
          this.formData.bodySaveDraft.tariffUuid = "";
        }
        if (e.status == 404) {
          // this.showTariff = false;
          this.tariffEmpty = false;
          this.tariffError = true;
          this.isRouteButtonDisabled = false;
          this.formData.bodySaveDraft.tariffUuid = "";
        }
      }
    },

    onRouteCompleted() {
      // this.step = 2;
      this.getOrder(this.$route.params.id);
    },

    onParametersCompleted() {
      // this.step = 3;
      this.saveOrder();
    },

    getLocationType(uuid) {
      return api.locations
        .getLocationType(uuid)
        .then((res) => {
          if (res.data.name === "Опорная точка") {
            return {
              showPoints: true,
              icon: "city-sm",
            };
          }
          return {
            showPoints: false,
            icon:
              this.$options.locationTypes[res.data.name.toLowerCase()] || "pin",
          };
        })
        .catch((e) => {
          console.error(e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных",
          });
        });
    },

    getContractors() {
      const requests = [
        api.organisations.getParticipantsbyRoleWithColor("CLICAR"),
      ];

      return Promise.all(requests)
        .then((res) => {
          this.formData.bodySaveDraft.contractorUuid = res[0].data[0].uuid;
          res[0].data.forEach((item) => {
            this.contractors.push({
              title: item.title,
              uuid: item.uuid,
              icon:
                item.roleCode === "CLICAR" || this.role === "clicar"
                  ? "role-domain-owner"
                  : "role-client",
              riskColor: item.riskColor,
            });
          });

          if (this.role === "clicar") {
            this.contractors = this.contractors.filter((item) => item.icon);
          }

          if (this.role === "anonymous") {
            this.contractors = this.contractors.filter(
              (item) => item.icon === "role-domain-owner"
            );
          }
        })
        .catch((e) => {
          console.error(e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных",
          });
        });
    },

    async getOrder(uuid) {
      return api.orders
        .getOrder(uuid)
        .then(async (response) => {
          this.formData = {
            bodySaveDraft: { ...response.data.responseDraft },
            creators: { ...response.data.creators },
            cargo: {
              ...response.data.cargo,
              etsngs: response.data.cargo.etsngs.length
                ? response.data.cargo.etsngs.map((item) => item.uuid)
                : [],
            },
            parameters: { ...response.data.parameters },
            logchain: { ...response.data.logchain },
            services: {
              ...(response.data.services || {
                contractNumber: "CTR19 123 4567",
                contractEffectiveD: "2020-02-14",
                baseServicePrice: 0,
                titleGeoraphy:
                  "Россия, Московская обл. г. Долгопрудный, ул. Новое шоссе, 34 → Россия, Самарская обл. г. Кинель, ул. Промышленная, 13",
                baseServices: [
                  {
                    baseServiceClientName:
                      "Перевозка крупнотоннажным автотранспортом Изотерм. 20 т / 86 м3 / 33 пал",
                    geography: "Москва → Самара",
                    count: 1,
                    price: 5800000,
                  },
                ],
              }),
            },
            actualTariff: { ...response.data.actualTariff },
            primeCost: { ...response.data.primeCost },
          };
          for (let point of this.formData.bodySaveDraft.route.points) {
            if (!point.childPoints) {
              point.childPoints = [];
            } else {
              for (let p of point.childPoints) {
                p.uuid = this.getUuid();
                if (p.type === "ADDRESS") {
                  const desc = await api.geocoder.getLocationDescription(
                    p.params.locationUuid
                  );
                  p.locationTitle = desc?.russian_name;
                }
              }
            }
          }

          if (!this.formData.bodySaveDraft.isPrivateContainer) {
            this.formData.bodySaveDraft.isPrivateContainer = false;
          }
          this.formData.parameters.insuranceCargo.currency = "RUR";
          if (!this.formData.parameters.serviceRequirements) {
            this.formData.parameters.serviceRequirements = [];
          }
          if (this.formData.bodySaveDraft.uploadedFromFile) {
            this.uploadedFromFile = true;
          }
          if (
            this.formData.parameters.cargoTypeUuid &&
            this.formData.parameters.insuranceCargo.cost &&
            !this.formData.bodySaveDraft.riskColor
          ) {
            this.cargoErrors = [
              {
                code: "INCOMPATIBILITY_COST_AND_TYPE",
                description:
                  "Перевозка груза указанного типа и страховой стоимости невозможна. Измените тип груза или страховую стоимость.",
              },
            ];
          } else {
            this.cargoErrors = [];
          }
          this.brif = cloneDeep(response.data.brif);
          this.formData.bodySaveDraft.clientUuid = this.formData.bodySaveDraft.client.uuid;

          this.formData.bodySaveDraft.contractorUuid = this.formData.bodySaveDraft.contractor.uuid;

          if (
            !this.formData.bodySaveDraft.orderSpecies ||
            !this.formData.bodySaveDraft.orderSpecies.length
          ) {
            this.formData.bodySaveDraft.orderSpecies = "QUOTA";
          }

          this.step = 1;

          if (
            this.formData.bodySaveDraft.page &&
            this.formData.bodySaveDraft.page !== "ROUTE"
          ) {
            // const index = this.$options.pageMap.indexOf(this.formData.bodySaveDraft.page) + 1;
            this.tariff = { ...response.data.actualTariff };
            this.actualTotal = new Intl.NumberFormat("ru-RU").format(
              this.tariff.totalPrice / 100
            );
            this.dataTotal = new Intl.NumberFormat("ru-RU").format(
              this.tariff.totalPrice / 100
            );
            this.mocks.services.base[0].price = new Intl.NumberFormat(
              "ru-RU"
            ).format(this.tariff.totalPrice / 100);
            this.mocks.selectedServices[0].price = new Intl.NumberFormat(
              "ru-RU"
            ).format(this.tariff.totalPrice / 100);
            // this.step = index;
          }

          if (!this.formData.bodySaveDraft.route) {
            this.formData.bodySaveDraft.route = {};
          }

          if (
            !this.formData.bodySaveDraft.route.departureDt &&
            !this.formData.bodySaveDraft.route.arriveDt
          ) {
            const date = new Date();
            date.setDate(date.getDate() + 1);
            date.setHours(12, 0, 0);
            this.formData.bodySaveDraft.route.departureDt = date;
          }

          const fromPoint = this.formData.bodySaveDraft.route?.points?.find(
            (item) => item.direction === "FROM"
          );
          // this.addressFrom.icon = fromPoint.params.locationTypeIcon ? fromPoint.params.locationTypeIcon.toLowerCase() : 'pin';
          if (fromPoint && fromPoint.params.uuid.length) {
            if (fromPoint.type === "REFERENCE_POSITION") {
              this.fromPointsShow = true;
              this.addressFrom.icon = "city-sm";
            }

            if (fromPoint.type === "ADDRESS" && fromPoint.params.locationUuid) {
              const desc = await api.geocoder.getLocationDescription(
                fromPoint.params.locationUuid
              );
              this.addressFrom.locationTitle = desc?.russian_name;
            }

            this.addressFrom.coordinates.lat = fromPoint.params.coordinates
              ? fromPoint.params.coordinates.lat
              : "";
            this.addressFrom.coordinates.lon = fromPoint.params.coordinates
              ? fromPoint.params.coordinates.lon
              : "";
            this.addressFrom.label = fromPoint.params.addressTitle || "";
          } else {
            this.formData.bodySaveDraft.route.points = [];
            this.formData.bodySaveDraft.route.points.push({
              ordinal: 1,
              direction: "FROM",
              visitPointCount: 1,
              type: "ADDRESS",
              childPoints: [],
              params: {
                uuid: "",
                coordinates: null,
                countryCode: "RUS",
                locationUuid: "",
                locationTypeUuid: "",
                addressTitle: "",
              },
            });
          }
          this.addressFrom.isValid = true;
          this.addressFrom.popoverMessage = "";

          const toPoint = this.formData.bodySaveDraft.route?.points?.find(
            (item) => item.direction === "TO"
          );
          // this.addressTo.icon = toPoint.params.locationTypeIcon ? toPoint.params.locationTypeIcon.toLowerCase() : 'pin';
          if (toPoint && toPoint.params.uuid.length) {
            if (toPoint.type === "REFERENCE_POSITION") {
              this.toPointsShow = true;
              this.addressTo.icon = "city-sm";
            }

            if (toPoint.type === "ADDRESS" && toPoint.params.locationUuid) {
              const desc = await api.geocoder.getLocationDescription(
                toPoint.params.locationUuid
              );
              this.addressTo.locationTitle = desc?.russian_name;
            }

            this.addressTo.coordinates.lat = toPoint.params.coordinates
              ? toPoint.params.coordinates.lat
              : "";
            this.addressTo.coordinates.lon = toPoint.params.coordinates
              ? toPoint.params.coordinates.lon
              : "";
            this.addressTo.label = toPoint.params.addressTitle || "";
          } else {
            this.formData.bodySaveDraft.route.points.push({
              ordinal: 2,
              direction: "TO",
              visitPointCount: 1,
              type: "ADDRESS",
              childPoints: [],
              params: {
                uuid: "",
                coordinates: null,
                countryCode: "RUS",
                locationUuid: "",
                locationTypeUuid: "",
                addressTitle: "",
              },
            });
          }

          this.addressTo.isValid = true;
          this.addressTo.popoverMessage = "";
          this.conditions = [
            ...(this.formData.bodySaveDraft.needTracking
              ? ["needTracking"]
              : []),
            ...(this.formData.bodySaveDraft.isDangerous ? ["isDangerous"] : []),
          ];
          if (!this.formData.bodySaveDraft.ftlParams) {
            this.formData.bodySaveDraft.ftlParams = {
              speciesUuids: "",
              typeUuids: "",
              count: "",
            };
          }
          if (this.role === "client") {
            this.checkContractor();
          }

          this.isLoading = false;
        })
        .catch((e) => {
          console.error(e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных",
          });
        });
    },

    async selectContractor(item) {
      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;
      this.clearFirstStepValidationField("carrierRole");
      this.formData.bodySaveDraft.contractorUuid = item.uuid;
      this.$refs.contractorSelect.select(item);
      if (this.isRouteValid && this.tariff) {
        this.showTariff = false;
        this.tariffEmpty = false;
        this.tariffError = false;
      }

      this.saveOrder("save");
    },

    setAddressFrom($event) {
      this.clearFirstStepValidationField("address");
      this.showTariff = false;
      this.priceForOnline = {};
      this.addressFrom = $event;
      this.addressFrom.isValid =
        !!this.addressFrom.coordinates.lat &&
        !!this.addressFrom.coordinates.lon;
      if (!this.addressFrom.isValid) {
        this.addressFrom.popoverMessage =
          "Адрес не найден. Выберите существующий адрес из списка или укажите точку на карте";
        return false;
      }
      if (!$event.icon) {
        this.addressFrom.icon = "pin";
      }

      const point = this.formData.bodySaveDraft.route.points.find(
        (item) => item.direction === "FROM"
      );

      if (this.addressFrom.icon && this.addressFrom.icon == "city-sm") {
        // опорная точка
        this.fromPointsShow = true;
        point.type = "REFERENCE_POSITION";
      } else if (
        this.addressFrom.icon &&
        this.addressFrom.icon !== "city-sm" &&
        this.addressFrom.icon !== "pin"
      ) {
        point.type = "INFRASTRUCTURE_FACILITY";
      } else {
        // не опорная точка
        this.fromPointsShow = false;
        point.type = "ADDRESS";
      }
      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;

      (point.params.countryCode = "RUS"),
        (point.params.coordinates = this.addressFrom.coordinates),
        (point.params.locationUuid = this.addressFrom.locationUuid || ""),
        (point.params.locationTypeUuid =
          this.addressFrom["location_type_uuid"] || ""),
        (point.params.addressTitle = this.addressFrom.label || "");
      this.saveOrder(false);
    },

    setAddressTo($event) {
      this.clearFirstStepValidationField("address");
      this.showTariff = false;
      this.priceForOnline = {};
      this.addressTo = $event;
      this.addressTo.isValid =
        !!this.addressTo.coordinates.lat && !!this.addressTo.coordinates.lon;
      if (!this.addressTo.isValid) {
        this.addressTo.popoverMessage =
          "Адрес не найден. Выберите существующий адрес из списка или укажите точку на карте";
        return false;
      }
      if (!$event.icon) {
        this.addressTo.icon = "pin";
      }

      const point = this.formData.bodySaveDraft.route.points.find(
        (item) => item.direction === "TO"
      );

      if (this.addressTo.icon && this.addressTo.icon == "city-sm") {
        // опорная точка
        this.toPointsShow = true;
        point.type = "REFERENCE_POSITION";
      } else if (
        this.addressTo.icon &&
        this.addressTo.icon !== "city-sm" &&
        this.addressTo.icon !== "pin"
      ) {
        point.type = "INFRASTRUCTURE_FACILITY";
      } else {
        // не опорная точка
        this.toPointsShow = false;
        point.type = "ADDRESS";
      }
      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;
      const newPoint = {
        countryCode: "RUS",
        coordinates: this.addressTo.coordinates,
        locationUuid: this.addressTo.locationUuid || "",
        locationTypeUuid: this.addressTo.location_type_uuid || "",
        addressTitle: this.addressTo.label || "",
      };
      point.params = { ...point.params, ...newPoint };
      this.saveOrder(false);
    },

    changePoints($event) {
      const from = this.formData.bodySaveDraft.route.points.find(
        (item) => item.direction === "FROM"
      );

      const to = this.formData.bodySaveDraft.route.points.find(
        (item) => item.direction === "TO"
      );

      from.visitPointCount = $event.fromPoints;
      to.visitPointCount = $event.toPoints;
      this.saveOrder(false);
      this.resetTariffSidebar();
    },

    setDate($event) {
      this.clearFirstStepValidationField("date");
      let timestamp = "";
      let year = new Date($event.date).getFullYear();
      let month = new Date($event.date).getMonth() + 1 + "";
      let day = new Date($event.date).getDate();
      let hour = new Date($event.date).getHours() + "";
      let minutes = new Date($event.date).getMinutes() + "";

      if ($event.type === "departure") {
        this.formData.bodySaveDraft.route.arriveDt = "";
        timestamp = Date.parse(
          `${year}-${month.padStart(2, 0)}-${(day + "").padStart(
            2,
            0
          )}T${hour.padStart(2, 0)}:${minutes.padStart(2, 0)}`
        );
        this.formData.bodySaveDraft.route.departureDt = new Date(timestamp);
      } else if ($event.type === "arrive") {
        const date = new Date();
        date.setDate(date.getDate() + 7);
        date.setHours(hour, minutes);
        const targetDate = new Date($event.date);
        if (date > targetDate) {
          year = new Date(date).getFullYear();
          month = new Date(date).getMonth() + 1 + "";
          day = new Date(date).getDate();
          hour = new Date(date).getHours() + "";
          minutes = new Date(date).getMinutes() + "";
        }
        timestamp = Date.parse(
          `${year}-${month.padStart(2, 0)}-${(day + "").padStart(
            2,
            0
          )}T${hour.padStart(2, 0)}:${minutes.padStart(2, 0)}`
        );
        this.formData.bodySaveDraft.route.arriveDt = new Date(timestamp);
        this.formData.bodySaveDraft.route.departureDt = "";
      }
      this.saveOrder(false);
      this.resetTariffSidebar();
    },

    onAddLoadingPoint() {
      const fromPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "FROM"
      );

      const ordinal = fromPoint.childPoints.length + 1;

      fromPoint.childPoints.push({
        uuid: uuid.v4(),
        ordinal: ordinal,
        direction: "FROM",
        visitPointCount: 1,
        type: "ADDRESS",
        icon: "",
        params: {
          uuid: "",
          coordinates: { lat: "", lon: "" },
          countryCode: "RUS",
          locationUuid: "",
          locationTypeUuid: "",
          addressTitle: "",
        },
      });
    },

    onAddUnloadingPoint() {
      const toPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "TO"
      );

      const ordinal = toPoint.childPoints.length + 1;

      toPoint.childPoints.push({
        uuid: uuid.v4(),
        ordinal: ordinal,
        direction: "TO",
        visitPointCount: 1,
        type: "ADDRESS",
        icon: "",
        params: {
          uuid: "",
          coordinates: { lat: "", lon: "" },
          countryCode: "RUS",
          locationUuid: "",
          locationTypeUuid: "",
          addressTitle: "",
        },
      });
    },

    onRemoveLoadingPoint($event) {
      let fromPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "FROM"
      );

      fromPoint.childPoints = fromPoint.childPoints.filter(
        (item) => item.uuid !== $event.uuid
      );
      this.saveOrder(false);
    },

    onRemoveUnloadingPoint($event) {
      let toPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "TO"
      );

      toPoint.childPoints = toPoint.childPoints.filter(
        (item) => item.uuid !== $event.uuid
      );

      this.saveOrder(false);
    },

    onSetAddresForLoadingPoint($event) {
      const fromPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "FROM"
      );

      const point = fromPoint.childPoints.find(
        (item) => item.uuid === $event.uuid
      );

      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;

      if ($event.icon && $event.icon == "city-sm") {
        // опорная точка
        point.type = "REFERENCE_POSITION";
      } else if (
        $event.icon &&
        $event.icon !== "city-sm" &&
        $event.icon !== "pin"
      ) {
        point.type = "INFRASTRUCTURE_FACILITY";
      } else {
        // не опорная точка
        point.type = "ADDRESS";
      }

      point.params.locationTypeIcon = $event.icon;
      point.params.countryCode = "RUS";
      point.params.coordinates = $event.coordinates;
      point.params.locationUuid = $event.locationUuid || "";
      point.locationTitle = $event.locationTitle;
      point.params.locationTypeUuid = $event.locationTypeUuid || "";
      point.params.addressTitle = $event.label || "";
      this.saveOrder(false);
    },

    onSetAddresForUnloadingPoint($event) {
      const toPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "TO"
      );

      const point = toPoint.childPoints.find(
        (item) => item.uuid === $event.uuid
      );

      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;

      if ($event.icon && $event.icon == "city-sm") {
        // опорная точка
        point.type = "REFERENCE_POSITION";
      } else if (
        $event.icon &&
        $event.icon !== "city-sm" &&
        $event.icon !== "pin"
      ) {
        point.type = "INFRASTRUCTURE_FACILITY";
      } else {
        // не опорная точка
        point.type = "ADDRESS";
      }

      point.params.locationTypeIcon = $event.icon;
      point.params.countryCode = "RUS";
      point.params.coordinates = $event.coordinates;
      point.params.locationUuid = $event.locationUuid || "";
      point.locationTitle = $event.locationTitle;
      point.params.locationTypeUuid = $event.locationTypeUuid || "";
      point.params.addressTitle = $event.label || "";
      this.saveOrder(false);
    },

    async onTransportationWaychanged($event) {
      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;
      this.formData.bodySaveDraft.serviceParams.serviceUuid = "";
      this.formData.bodySaveDraft.transportationWay = $event;
      // await this.setTransports();
      await this.getTransports();

      this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = this.transports[0].uuid;

      // await this.changeTransport();
      const types = await api.orders.getTransportTypes(
        this.$route.params.id,
        this.formData.bodySaveDraft.serviceParams.serviceTypeUuid
      );
      this.transportTypes = types;
      if (this.formData.bodySaveDraft.transportationWay === "CONTAINER") {
        this.formData.bodySaveDraft.isPrivateContainer = true;
      }
      if (
        this.formData.bodySaveDraft.transportationWay === "CONTAINER" ||
        this.formData.bodySaveDraft.transportationWay === "RAIL"
      ) {
        api.resources
          .getForwardingUnitList()
          .then((res) => {
            this.accountingItems = res.data.content.reduce((acc, item) => {
              acc.push({ uuid: item.uuid, title: item.denomination });
              return acc;
            }, []);
          })
          .catch((e) => {
            console.error(e);
            this.$notification({
              type: "system_notification_error",
              message: "Ошибка загрузки данных",
            });
          });
      }
      this.saveOrder(false);
      await this.getTemperatureRegim();
    },

    async onTransportChanged($event) {
      this.formData.bodySaveDraft.serviceParams.serviceUuid = "";
      this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = $event;
      await this.changeTransport("save");
    },

    async onTransportTypeChanged($event) {
      this.firstStepErrors.transportType.valid = true;
      this.firstStepErrors.transportType.errorTooltip = "";
      this.formData.bodySaveDraft.serviceParams.serviceUuid = $event;
      this.priceForOnline = {};
      this.showTariff = false;
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isLogchainError = false;
      await this.saveOrder(false);
      await this.getTemperatureRegim();
    },

    onTransportQtyChanged($event) {
      this.formData.bodySaveDraft.ftlParams.count = $event;
      this.formData.bodySaveDraft.serviceParams.count = $event;
      this.saveOrder(false);
      this.resetTariffSidebar();
    },

    async changeTransport(save) {
      try {
        this.getTranspotTypes();
        this.showTariff = false;
        this.tariffEmpty = false;
        this.tariffError = false;
        if (save) {
          this.saveOrder(false);
        }
        await this.getTemperatureRegim();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных",
        });
      }
    },

    async getTranspotTypes() {
      try {
        const types = await api.orders.getTransportTypes(
          this.$route.params.id,
          this.formData.bodySaveDraft.serviceParams.serviceTypeUuid
        );
        if (this.formData.bodySaveDraft.serviceParams.serviceTypeUuid === '56eaa734-ad65-47e2-b961-80797818e935') {
          const itemsToInclude = ['f3281ffa-c152-454c-b8f3-7fcb9f4d4972', '86ddebf4-af2f-45d4-8fe2-8cd61d22428a', '9a024731-ad92-4c94-abd0-c72bf0398106'];
          const filteredData = types.filter(item => itemsToInclude.includes(item.uuid));
          this.transportTypes = filteredData;
        } else {
          this.transportTypes = types;
        }
      } catch (e) {
        console.error(e);
      }
    },

    onconditionsSelect($event) {
      this.formData.bodySaveDraft.isDangerous = false;
      this.formData.bodySaveDraft.needTracking = false;
      for (let item of $event) {
        this.formData.bodySaveDraft[item] = true;
      }
      this.saveOrder(false);
      this.resetTariffSidebar();
    },

    async ontemperatureSelect($event) {
      this.formData.bodySaveDraft.temperatureRegimeUuid =
        $event.temperatureModeRootUuid;
      this.formData.bodySaveDraft.temperatureModeUuid =
        $event.temperatureModeUuid;
      await this.saveOrder(false);
      await this.getTranspotTypes();
      this.resetTariffSidebar();
    },

    onCargoTypeChange($event) {
      if (this.step === 1) {
        this.resetTariffSidebar();
      }
      this.formData.parameters.cargoTypeUuid = $event;
      this.saveOrder();
    },

    onInsuranceCostChange($event) {
      if (this.step === 1) {
        this.resetTariffSidebar();
      }
      this.formData.parameters.insuranceCargo.cost = $event;
      this.saveOrder();
    },

    onCargoCodeChanged($event) {
      this.resetTariffSidebar();
      this.formData.cargo.etsngs = $event;
      this.saveOrder(false);
    },

    checkCargoErrors(data) {
      const cargoErrorsCodes = ["MAX_COST", "NO_COST"];
      const errors = data.errors.reduce((acc, item) => {
        if (cargoErrorsCodes.some((code) => code === item.code)) {
          acc.push(item);
        }
        return acc;
      }, []);
      this.errors.record("CARGO_ERRORS", errors);
    },

    onCommentsChanged($event) {
      this.formData.parameters.comments = $event;
      this.saveOrder(false);
    },

    onCargoChanged($event) {
      if (this.step === 1) {
        this.resetTariffSidebar();
      }
      this.formData.cargo[$event.field] = $event.value;
      this.saveOrder(false);
    },

    onCargoWeightChanged($event) {
      if (this.step === 1) {
        this.resetTariffSidebar();
      }
      this.formData.cargo.weightInKg = $event;
      this.saveOrder(false);
    },

    onNumberChanged($event) {
      this.formData.bodySaveDraft.externalNumber = $event;
      this.saveOrder(false);
    },

    async onContactChanged($event) {
      this.formData.parameters.contactPerson.fio = $event;
      this.formData.parameters.contactPerson.phone = "";
      await this.saveOrder(false);
      this.getPhones(this.formData.parameters.contactPerson.fio);
    },

    async onContactAdded($event) {
      this.formData.parameters.contactPerson.fio = $event.fio;
      this.formData.parameters.contactPerson.phone = "";
      await this.saveOrder(false);
      this.getContacts();
      this.getPhones(this.formData.parameters.contactPerson.fio);
    },

    async onContactPhoneAdded($event) {
      this.formData.parameters.contactPerson.phone = $event.phone;
      await this.saveOrder(false);
      this.getPhones(this.formData.parameters.contactPerson.fio);
    },

    async onContactPhoneChanged($event) {
      this.formData.parameters.contactPerson.phone = $event;
      await this.saveOrder(false);
      if (this.formData.parameters.contactPerson) {
        this.getPhones(this.formData.parameters.contactPerson.fio);
      }
    },

    onFreightForwardingUnitUuidChanged($event) {
      if (this.step === 1) {
        this.resetTariffSidebar();
      }
      this.formData.cargo.freightForwardingUnitUuid = $event;
      this.saveOrder(false);
    },

    onSecurityChanged($event) {
      this.formData.parameters.serviceRequirements = [...$event];
      this.saveOrder(false);
    },

    async onTransportCountChanged($event) {
      try {
        await api.orders.updateParameters(this.$route.params.id, $event);
        await this.getOrder(this.$route.params.id);
      } catch (error) {
        console.error(error);
      }
    },

    async getTariff() {
      this.tariffEmpty = false;
      this.tariffError = false;
      this.isSearchingTariff = true;
      this.isRouteButtonDisabled = true;
      this.actualTariff = "";
      this.isOnlyManualTariff = false;
      this.formData.bodySaveDraft.tariffUuid = "";
      let contractorUuid;
      if (
        this.formData.bodySaveDraft.orderType === "TMS" ||
        ["1", "2"].includes(this.formData.bodySaveDraft.contractorUuid)
      ) {
        contractorUuid = "54d0de87-99a2-4771-9c33-e9ac4ebf5fb1";
      } else {
        contractorUuid = this.formData.bodySaveDraft.contractorUuid;
      }
      return api.orders
        .getOrderTariff(this.$route.params.id, {
          contractorUuid,
          contractType: "SHIPPING",
          clientUuid: this.contractorUuid,
          // contractorUuid: this.formData.bodySaveDraft.contractorUuid == '1' || this.formData.bodySaveDraft.contractorUuid == '2' ? "54d0de87-99a2-4771-9c33-e9ac4ebf5fb1" : this.formData.bodySaveDraft.contractorUuid,
        })
        .then((res) => {
          if (res.error) {
            this.tariffByHandValue = null;
            if (res.status == 404) {
              this.tariffEmpty = true;
              this.isSearchingTariff = false;
              this.showTariff = true;
              this.isRouteButtonDisabled = false;
              this.actualTariff = this.role === "client" ? "onlinePrice" : "";
              return false;
            } else {
              this.actualTariff = "";
              this.tariffError = true;
              this.isSearchingTariff = false;
              this.tariffEmpty = false;
              this.showTariff = true;
              this.isRouteButtonDisabled = false;
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка загрузки данных",
              });
            }
          } else if (res.data && res.data.tariffInfo.length) {
            this.isSearchingTariff = false;
            this.tariffError = false;
            this.tariffEmpty = false;
            this.showTariff = true;
            this.isRouteButtonDisabled = false;
            this.tariff = res.data;
          }
        })
        .catch((e) => {
          console.error(e.status);
          if (e.status == 404) {
            this.tariffEmpty = true;
            this.isSearchingTariff = false;
            this.showTariff = true;
            this.isRouteButtonDisabled = false;
            this.actualTariff = this.role === "client" ? "onlinePrice" : "";

            if (
              this.formData.bodySaveDraft.orderType === "TMS" &&
              this.formData.bodySaveDraft.client.roleCode === "CLIENT"
            ) {
              this.FindLogchainsForOnlinePrice();
            }
          } else {
            this.actualTariff = "";
            this.tariffError = true;
            this.isSearchingTariff = false;
            this.showTariff = true;
            this.$notification({
              type: "system_notification_error",
              message: "Ошибка загрузки данных",
            });
            this.isLogchainError = true;
          }
        });
    },

    async saveOrder(reload = true) {
      //TODO may be this block should be removed
      // if(this.role === 'clicar'){
      //   this.formData.bodySaveDraft.clientUuid = this.uuid;
      // }

      this.isSaving = true;
      const hasId = this.$route.params.id !== "new-order";
      const newUUID = !hasId ? uuid.v4() : this.$route.params.id;
      let notificationId = new Date().getTime() + "save";
      try {
        this.$notification({
          type: "system_notification_in_load",
          message: "Сохранение",
          id: notificationId,
        });
        if (!hasId) {
          const number = await api.orders.getOrderId();
          this.formData.bodySaveDraft.number = number.data.code;
          // if (this.role === "clicar") {
          //   this.formData.bodySaveDraft.contractorUuid = this.contractorUuid;
          // }
          this.formData.creators = {
            userUuid: this.userUuid,
            contractorUuid: this.contractorUuid,
          };
        }

        // this.formData.bodySaveDraft.page = this.$options.pageMap[this.step - 1];

        const payload = {
          ...this.formData,
          cargo: {
            ...this.formData.cargo,
            etsngs: this.formData.cargo.etsngs.map((item) => ({ uuid: item })),
          },
        };

        const saved = await api.orders.saveOrder(newUUID, payload);
        this.checkCargoErrors(saved.data);
        if (!hasId && this.role !== "anonymous")
          this.$router.push(`/order-drafts-item/${newUUID}`);
        if (!hasId && this.role === "anonymous")
          this.$router.push(`/order-item-guest/${newUUID}`);
        this.$notification({
          type: "system_notification_success",
          message: "Сохранено",
        });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Не сохранено",
        });
        throw e;
      } finally {
        if (reload) {
          await this.getOrder(newUUID);
        }
        this.$notification({ event: "close", id: notificationId });
        this.isSaving = false;
      }
    },

    handleVisitPointUpdate() {
      this.getOrder(this.$route.params.id);
    },
    saveAndExit() {
      this.$refs.exitOrder.open();
    },
  },

  beforeDestroy() {
    clearTimeout(this.logchainFindTimeout);
  },

  beforeRouteLeave(to, from, next) {
    const message =
      to.name === "order__item"
        ? `Заказ ${this.formData.bodySaveDraft.number} оформлен`
        : `Черновик заказа ${this.formData.bodySaveDraft.number} сохранён`;

    this.$notification({
      type: "snackbars",
      message,
    });
    next();
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-order {
  margin: 20px;
  background-color: #e4edf9;
  border-radius: 3px;
  position: relative;
  width: calc(100% - 40px);
}

.ob-order__header {
  display: flex;
  width: calc(100% - 316px);
  min-height: 60px;
  padding: 14px 20px 0 20px;
  position: relative;
  z-index: 1;
  box-shadow: 0 0 10px -4px rgba(0, 75, 200, 0.6);
  background-color: $background-white;
}

.ob-order__header-content {
  width: 100%;
}

.order-info {
  @include font-mixin(24px, 28px, 700, $style-black);
  display: flex;
  align-items: center;

  .icon {
    margin-right: 9px;
    font-size: 12px;
    font-weight: 400;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: #004bc8;
    text-transform: none;
    text-decoration: none;
  }

  span {
    font-size: 14px;
    font-weight: 400;
    line-height: 20px;
    letter-spacing: 0.4px;
    color: $color-error;
    text-transform: uppercase;
    opacity: 0.8;
    font-variant: small-caps;
    mix-blend-mode: normal;
    margin-left: 5px;

    &.status {
      align-self: flex-start;
      font-size: 10px;
    }
  }

  .ob-menu-dropdown-container {
    margin-left: auto;
    top: 12px;
  }

  &::v-deep {
    .ob-menu-dropdown-container .menu-dropdown-list__item button .col-left i {
      font-size: 20px;
    }

    .ob-menu-dropdown-container
      .menu-dropdown-list__item
      button
      .col-left
      i:before {
      color: $blue-700;
    }

    .ob-menu-dropdown-container
      .menu-dropdown-list__item.error
      .col-left
      i:before {
      color: $color-error;
    }
  }
}

.order-details {
  margin-top: 6px;
  display: flex;
  align-items: center;

  &::v-deep {
    .ob-inline-select__label i {
      margin-left: 0;
    }
  }
}
.order-contractor {
  padding: 0 5px 0 8px;
  letter-spacing: 0.2px;
  font-size: 14px;
  line-height: 20px;

  span {
    color: $color-error;
  }
}

.ob-order__content {
  width: 100%;
  display: flex;
  justify-content: space-between;
  position: relative;
  background-color: $background-white;
}

.ob-order__content-left {
  width: calc(100% - 316px);
  max-width: 970px;
}

.ob-order__content-right {
  position: relative;
  z-index: 2;
  margin-top: -60px;
  box-shadow: 0 0 10px -4px rgba(0, 75, 200, 0.6);
  background: $background-white;
  width: 316px;
  min-height: calc(100vh - 40px);
}

.ob-order__content-right-container {
  position: sticky;
  top: 0;
}

.ob-order__logist {
  padding: 27px 30px 8px;
  border-bottom: 1px solid $color-grey-border;
  position: relative;
}

.ob-order__logist-quota {
  position: absolute;
  right: 30px;
  top: 13px;
  color: $gray-slate;
  font-size: 10px;
  line-height: 12px;
  letter-spacing: 0.4px;

  span {
    display: flex;
    align-items: center;
  }

  i {
    margin-left: 3px;
    color: $blue-700;
    font-size: 14px;
  }
}

.ob-order__logist-row {
  margin-bottom: 14px;

  .icon {
    color: #004bc8;
  }
}

.ob-order__logist-section {
  margin-top: -5px;
  display: flex;
  align-items: center;
}

.ob-order__logist-label {
  @include font-mixin(10px, 12px, 400, $gray-slate, 0.4px);
  margin: 2px 0;
  mix-blend-mode: normal;
}

.ob-order__logist-value {
  @include font-mixin(14px, 20px, 400, $gray-slate);
  margin: 0 5px;
}

.ob-order__status {
  padding: 20px 30px 10px;
}

.ob-order__status-item {
  display: flex;
  align-items: center;
  margin-bottom: 15px;
  font-size: 12px;
  line-height: 15px;

  .icon {
    margin-right: 9px;
    font-size: 16px;
    color: $color-grey-border;
  }
}

.ob-order__action {
  display: flex;
  justify-content: center;
  margin-top: 30px;
}

.order-step {
  padding: 20px 19px 10px;
}

.order-step__header {
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 27px;

  div {
    display: flex;
    align-items: center;

    &:not(:last-child) {
      margin-right: 30px;
    }
  }
}

.upload {
  display: none !important;
  align-self: flex-end;
  align-items: center;
  justify-content: center;

  &__xls {
    margin: 0 7px;
    font-size: 12px;
  }

  &__icon {
    line-height: 100%;
    padding-top: 4px;
    color: #004bc8;
  }
}

.order-step__contractor {
  display: flex;
  align-items: center;

  .icon {
    display: flex;
    margin-left: 10px;
    color: #004bc8;
  }
}

.order-route__row {
  width: 100%;
  display: flex;
  margin: 8px 0 8px 0;
}

.order-step__method {
  margin-top: 42px;
}

.order-methods {
  margin-bottom: 32px;
  display: flex;
}

.order-method-options {
  display: flex;
  margin-bottom: 30px;

  .form-item-container {
    margin-right: 10px;
    margin-bottom: 0;
    min-width: 180px;

    &:first-child {
      flex: 1 0 0;
    }

    &:nth-child(2) {
      flex: 3 0 0;
    }
  }

  .ob-stepper-container {
    width: 150px;
  }
}

.placeholder {
  background-color: $background-white;
  display: flex;
  font-size: 20px;
}

.ctrl-group .ob-button-container {
  display: flex;
  width: auto;
  padding: 0 15px;
  max-width: none;
  min-width: 135px;
  background: $background-white;
  color: $cobalt-blue;

  &.active,
  &:hover {
    background-color: $blue-blue-hoarfrost !important;
    color: $cobalt-blue !important;
  }

  border-radius: 0;
  height: 52px;
  border-left: 1px solid $color-grey-border;

  &:first-child {
    border: none;
  }
}

.order-step__rout-info {
  margin: 0 -20px 0;
  height: 200px;
  background-color: $background-white;
  display: flex;
  justify-content: center;
  align-items: center;
  box-shadow: 0px 4px 16px rgba(0, 75, 200, 0.2);
  border-radius: 4px;
  font-size: 24px;
}

.order-step__weight {
  margin-top: 19px;
}

.input-group {
  display: flex;
  margin-bottom: 24px;

  & > * {
    margin-right: 20px;
  }
}

.accounting {
  display: flex;

  .ob-selector {
    margin-right: 22px;
    max-width: 390px;
  }
}

.order-step__sides {
  margin-top: 26px;
}

.order-step__cards-container {
  display: flex;
}

.order-step__card {
  flex-grow: 1;
  max-width: 495px;
  padding-right: 105px;
}

.order-step__card-item {
  width: 100%;
}

.order-step__card-header {
  margin-bottom: 5px;
  font-size: 14px;
  color: $gray-slate;
}

.order-step__type {
  margin-top: 40px;

  .ob-selector {
    max-width: 653px;
  }
}

.order-ensurance {
  margin-top: 20px;
  display: flex;
  align-items: center;

  .ob-input-container {
    width: 100%;
    max-width: 317px;
  }
}

.order-ensurance__risk {
  margin-left: 24px;
  display: flex;
  align-items: center;

  span {
    width: 18px;
    height: 18px;
    display: flex;
    justify-content: center;
    align-items: center;
    border-radius: 50%;
    color: #ffffff;
    font-size: 11px;
    background-color: $light-denim;
    margin-right: 7px;
  }
}

.order-step__contacts {
  margin-top: 36px;
}

.order-step__security {
  margin-top: 40px;
}

.order-step__services {
  margin-top: 40px;
  background-color: pink;
}

.order-step__service-items {
  margin-top: 60px;
}

.platform-services {
  display: flex;
  margin-bottom: 40px;

  & > .service {
    flex: 0 0 164px;

    &:not(:last-child) {
      margin-right: 9px;
    }
  }
}

.order-step__service-route {
  padding: 24px;
  font-size: 12px;
  color: #191e32;
  background-color: $background-color-light;

  button {
    margin-right: 28px;
    border: none;
    outline: none;
    background-color: transparent;
    appearance: none;
    font-size: 16px;
    color: #004bcb;
    transition: all 0.2s ease-in-out;
  }

  .closed {
    transform: rotate(180deg);
  }
}

table {
  width: 100%;
  text-align: left;
  font-size: 14px;
  color: #191e32;
  border: 1px solid $lavender;

  th {
    padding: 10px;
    font-size: 11px;
    color: $shale-gray;
    text-transform: uppercase;
    font-weight: 400;

    &:first-child {
      width: 5%;
    }

    &:nth-child(2) {
      width: 40%;
    }

    &:nth-child(3) {
      width: 20%;
    }

    &:nth-child(4) {
      width: 10%;
    }

    &:last-child {
      width: 15%;
    }
  }

  td {
    padding: 10px;
    border-top: 1px solid $lavender;
  }

  .number {
    text-align: right;
  }
}

.services-list {
  margin-bottom: 20px;
  margin-top: 17px;
  font-weight: 400;

  li {
    display: flex;
    align-items: center;
    justify-content: space-between;
    font-size: 12px;

    &:not(:last-child) {
      margin-bottom: 9px;
    }
  }
}

.services-total {
  border-top: 1px solid $color-grey-border;
  padding-top: 20px;
  margin-bottom: 30px;
  color: $gray-slate;

  h3 {
    display: flex;
    align-items: center;
    justify-content: space-between;
    color: $color-text-base;

    .currency {
      font-size: 20px;
    }
  }
}

.oferta {
  padding-top: 27px;
  padding-right: 27px;
  margin-bottom: 20px;
  display: flex;
  border-top: 1px solid $color-grey-border;
  font-size: 12px;
  color: $gray-slate;

  a {
    color: $orderPage-oferta_link_color;
  }
}

.ob-inline-select__list-item {
  display: flex;
  align-items: center;
  font-size: 14px;
  letter-spacing: 0.2px;
  color: #191e32;
  padding: 8px 16px;
  cursor: pointer;
  white-space: nowrap;

  &:first-child {
    margin-top: 8px;
  }
  &:last-child {
    margin-bottom: 8px;
  }

  &:hover {
    background-color: $blue-blue-hoarfrost;
  }

  &.top {
    border-bottom: 1px solid rgba(209, 210, 214, 0.3);
  }

  .icon {
    margin-right: 5px;
    color: #004bc8;
  }
}

.ob-order-info-status__tafiff {
  margin-bottom: 30px;
}

.tariff-loader {
  @include font-mixin(20px, 28px, 700, $blue-700, 0.4px);
  text-align: center;

  img {
    max-width: 100%;
  }

  &--tms {
    h2 {
      display: flex;
      @include font-mixin(16px, 20px, 700, $color-blue-smalt, 0.4px);
      text-align: left;

      i {
        margin-right: 16px;
        font-size: 24px;
      }
    }

    .preloader {
      position: relative;
      display: flex;
      justify-content: center;
    }

    &::v-deep {
      .loader {
        width: 50px;
        height: 50px;
        margin: 20px 0 10px;
        top: auto;
        left: auto;
      }
    }

    span {
      @include font-mixin(14px, 16px, 400, $gray-slate, 0.4px);
    }
  }
}

::v-deep {
  .order-step-title {
    margin: 0 0 7px;
    font-weight: bold;
    font-size: 20px;
    line-height: 28px;
    letter-spacing: 0.4px;
    color: #191e32;
    display: flex;
    align-items: center;

    .icon {
      display: flex;
      margin-left: 6px;
      color: $color-grey-border;
    }

    &.active {
      .icon {
        color: $color-green-light;
      }
    }

    &--services {
      display: flex;
      align-items: center;

      span {
        margin-left: 10px;
        @include font-mixin(16px, 24px, 700, $gray-slate);
      }
    }
  }
  .ob-inline-select {
    margin-right: 18px;
    &__label {
      i {
        margin-left: 9px;
      }
    }
  }
}

.order-step__misc {
  margin-top: 40px;
}

.order-step__misc-item {
  padding: 0 17px;
  display: flex;
  align-items: center;
  height: 40px;
  background-color: $light-lavender;
  @include font-mixin(16px, 20px, 400, #004bc8);
  border-bottom: 1px solid #d6e2f6;

  button {
    margin-right: 18px;
    border: none;
    outline: none;
    background-color: transparent;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-size: 16px;
    color: #004bcb;
    -webkit-transition: all 0.2s ease-in-out;
    transition: all 0.2s ease-in-out;
    @include font-mixin(16px, 20px, 400, #004bc8);

    .icon {
      display: inline-block;
      transform: rotate(180deg);
    }
  }

  .closed .icon {
    transform: rotate(90deg);
  }
}

.order-step__actions {
  display: flex;
  align-items: center;
  margin: 30px 0;
  background-color: pink;
}

.validation-buttons {
  display: flex;
}

.icon.checked {
  color: $color-green-light;
}

.ob-order-info-actions {
  padding: 20px 30px;
  height: 70px;
  position: absolute;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  align-items: center;
  justify-content: center;

  button {
    @include font-mixin(14px, 20px, 400);
  }

  button:first-child {
    flex-grow: 1;
  }

  button:last-child {
    @include font-mixin(16px, 20px, 400, $color-error);
  }
}

.prime-cost {
  margin-bottom: 20px;
  border-bottom: 1px solid rgba(209, 210, 214, 0.5);
}

.profit {
  &--positive {
    color: $green-craiola !important;
  }

  &--negative {
    color: $color-error;
  }

  &:first-child {
    margin-left: auto;
    margin-right: 20px;
  }
}

.saved-popup-preloader {
  height: 100px;
  position: relative;

  &::v-deep {
    .preloader {
      position: absolute;
      display: flex;
      justify-content: center;
      align-items: flex-end;
    }

    .loader {
      width: 80px;
      height: 80px;
      margin: 0;
      position: static;
    }
  }
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
}
</style>

<style lang="scss">
.order-method-options {
  .ob-selector {
    margin-right: 10px;
    &:last-child {
      margin-right: 0;
    }
    &__select {
      height: 52px;
    }
  }
  .transport-type-select {
    width: 100% !important;
  }
}

.list-item {
  &__icon,
  &__title {
    opacity: 0.5;
  }
  &__red {
    color: red;
    margin-left: 10px;
  }
  &__disabled {
    pointer-events: none;
  }
}

.oferta-map {
  h2 {
    margin-bottom: 1em;
  }

  p + h2 {
    margin-top: 1em;
  }

  ul,
  ol {
    margin: 1em 0;
    font-family: "Roboto", sans-serif;
    font-size: 14px;
    font-weight: 400;
    line-height: 18px;
    letter-spacing: 0.2px;
    color: #000000;
    list-style: inside;
  }

  ol {
    list-style-type: revert;
  }

  .modal-body p + p {
    margin-top: 1em;
  }
}

.copy-modal {
  .modal-header .title {
    align-items: center;
  }

  .preloader {
    position: relative;
    display: flex;
    justify-content: center;
  }

  .loader {
    width: 50px;
    height: 50px;
    margin: 20px 0 10px;
    top: auto;
    left: auto;
  }
}

.logist-select {
  z-index: 2000;
  position: fixed;
}

// .new-main-menu,
// .ob-main-template-header{
//   display: none !important;
// }

body .ob-main-template .ob-main-template-center-section {
  padding: 0;
}

.anon-auth-modal .ob-ty-modal-title {
  text-align: center;
  font-size: 20px;
  line-height: 28px;
  font-weight: 700;
}

.anon-header {
  position: static !important;
  height: 64px !important;
  box-shadow: 0px 4px 16px rgba(1, 36, 94, 0.4);
  background-color: red;
  margin-left: -20px;
  margin-right: -20px;
  margin-top: -20px;
  margin-bottom: 20px;
  padding: 16px 20px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  color: white;

  svg {
    width: 108px;
  }

  i {
    margin-left: 10px;
    font-size: 20px;
  }
}

.anon-header__info {
  display: flex;
  align-items: center;
}
</style>
